# Cinder

# cinder::ImageTarget Class Reference

`#include <ImageIo.h>`

Inherits cinder::ImageIo.

Inherited by cinder::cocoa::ImageTargetCgImage, cinder::gl::ImageTargetGLTexture< T >, cinder::ImageTargetChannel< T >, cinder::ImageTargetFileWic, and cinder::ImageTargetSurface< T >.

List of all members.

## Public Types
enum | ColorModel { CM_RGB, CM_GRAY, CM_UNKNOWN }
typedef enum cinder::ImageIo::ColorModel | ColorModel
enum | DataType { UINT8, UINT16, FLOAT32, DATA_UNKNOWN }
typedef enum cinder::ImageIo::DataType | DataType
enum | ChannelType { CHAN_RGB_R, CHAN_RGB_G, CHAN_RGB_B, CHAN_GRAY, CHAN_ALPHA, CHAN_MASK, CHAN_LAB_L, CHAN_LAB_A, CHAN_LAB_B, CHAN_YUV_Y, CHAN_YUV_U, CHAN_YUV_V, CHAN_CMYK_C, CHAN_CMYK_M, CHAN_CMYK_Y, CHAN_CMYK_K, CHAN_UNKNOWN }
typedef enum cinder::ImageIo::ChannelType | ChannelType
enum | ChannelOrder { RGBA, BGRA, ARGB, ABGR, RGBX, BGRX, XRGB, XBGR, RGB, BGR, Y, YA, CUSTOM }
typedef enum cinder::ImageIo::ChannelOrder | ChannelOrder
## Public Member Functions
virtual | ~ImageTarget ()
virtual void * | getRowPointer (int32_t row)=0
virtual void | setRow (int32_t row, const void *data)
virtual void | finalize ()
int32_t | getWidth () const
int32_t | getHeight () const
ColorModel | getColorModel () const
DataType | getDataType () const
ChannelOrder | getChannelOrder () const
virtual bool | hasAlpha () const
## Static Public Member Functions
static void | translateRgbColorModelToOffsets (ChannelOrder channelOrder, int8_t *red, int8_t *green, int8_t *blue, int8_t *alpha, int8_t *inc)
static void | translateGrayColorModelToOffsets (ChannelOrder channelOrder, int8_t *gray, int8_t *alpha, int8_t *inc)
static bool | channelOrderHasAlpha (ChannelOrder channelOrder)
static int8_t | channelOrderNumChannels (ChannelOrder channelOrder)
static uint8_t | dataTypeBytes (DataType dataType)
static std::vector< std::string > | getLoadExtensions ()
static std::vector< std::string > | getWriteExtensions ()
## Protected Member Functions
| ImageTarget ()
void | setSize (int32_t width, int32_t height)
void | setColorModel (ColorModel colorModel)
void | setDataType (DataType aDataType)
void | setChannelOrder (ChannelOrder aChannelOrder)
## Protected Attributes
int32_t | mWidth
int32_t | mHeight
ColorModel | mColorModel
DataType | mDataType
ChannelOrder | mChannelOrder

## Member Typedef Documentation

typedef enum cinder::ImageIo::ColorModel cinder::ImageIo::ColorModel`[inherited]`

typedef enum cinder::ImageIo::DataType cinder::ImageIo::DataType`[inherited]`

typedef enum cinder::ImageIo::ChannelType cinder::ImageIo::ChannelType`[inherited]`

typedef enum cinder::ImageIo::ChannelOrder cinder::ImageIo::ChannelOrder`[inherited]`

## Member Enumeration Documentation

enum cinder::ImageIo::ColorModel`[inherited]`

Enumerator:

  CM_RGB |
  CM_GRAY |
  CM_UNKNOWN |

enum cinder::ImageIo::DataType`[inherited]`

Enumerator:

  UINT8 |
  UINT16 |
  FLOAT32 |
  DATA_UNKNOWN |

enum cinder::ImageIo::ChannelType`[inherited]`

Enumerator:

  CHAN_RGB_R |
  CHAN_RGB_G |
  CHAN_RGB_B |
  CHAN_GRAY |
  CHAN_ALPHA |
  CHAN_MASK |
  CHAN_LAB_L |
  CHAN_LAB_A |
  CHAN_LAB_B |
  CHAN_YUV_Y |
  CHAN_YUV_U |
  CHAN_YUV_V |
  CHAN_CMYK_C |
  CHAN_CMYK_M |
  CHAN_CMYK_Y |
  CHAN_CMYK_K |
  CHAN_UNKNOWN |

enum cinder::ImageIo::ChannelOrder`[inherited]`

Enumerator:

  RGBA |
  BGRA |
  ARGB |
  ABGR |
  RGBX |
  BGRX |
  XRGB |
  XBGR |
  RGB |
  BGR |
  Y |
  YA |
  CUSTOM |

## Constructor & Destructor Documentation

virtual cinder::ImageTarget::~ImageTarget | ( |  | ) | `[virtual]`

cinder::ImageTarget::ImageTarget | ( |  | ) | `[protected]`

## Member Function Documentation

virtual void* cinder::ImageTarget::getRowPointer | ( | int32_t | row | ) | `[pure virtual]`

Implemented in cinder::cocoa::ImageTargetCgImage, and cinder::ImageTargetFileWic.

virtual void cinder::ImageTarget::setRow | ( | int32_t | row,
|  | const void * | data |
| ) |  |  | `[virtual]`

virtual void cinder::ImageTarget::finalize | ( |  | ) | `[virtual]`

Reimplemented in cinder::cocoa::ImageTargetCgImage, cinder::ImageTargetFileQuartz, cinder::ImageTargetFileUiImage, and cinder::ImageTargetFileWic.

int32_t cinder::ImageIo::getWidth | ( |  | ) | const`[inherited]`

int32_t cinder::ImageIo::getHeight | ( |  | ) | const`[inherited]`

ColorModel cinder::ImageIo::getColorModel | ( |  | ) | const`[inherited]`

DataType cinder::ImageIo::getDataType | ( |  | ) | const`[inherited]`

ChannelOrder cinder::ImageIo::getChannelOrder | ( |  | ) | const`[inherited]`

virtual bool cinder::ImageIo::hasAlpha | ( |  | ) | const`[virtual, inherited]`

void cinder::ImageIo::translateRgbColorModelToOffsets | ( | ChannelOrder | channelOrder,
|  | int8_t * | red,
|  | int8_t * | green,
|  | int8_t * | blue,
|  | int8_t * | alpha,
|  | int8_t * | inc |
| ) |  |  | `[static, inherited]`

void cinder::ImageIo::translateGrayColorModelToOffsets | ( | ChannelOrder | channelOrder,
|  | int8_t * | gray,
|  | int8_t * | alpha,
|  | int8_t * | inc |
| ) |  |  | `[static, inherited]`

bool cinder::ImageIo::channelOrderHasAlpha | ( | ChannelOrder | channelOrder | ) | `[static, inherited]`

int8_t cinder::ImageIo::channelOrderNumChannels | ( | ChannelOrder | channelOrder | ) | `[static, inherited]`

uint8_t cinder::ImageIo::dataTypeBytes | ( | DataType | dataType | ) | `[static, inherited]`

vector< string > cinder::ImageIo::getLoadExtensions | ( |  | ) | `[static, inherited]`

Returns a vector of the extensions ImageIo supports for loading. Suitable for the extensions parameters of getOpenFilePath()

vector< string > cinder::ImageIo::getWriteExtensions | ( |  | ) | `[static, inherited]`

Returns a vector of the extensions ImageIo supports for writing. Suitable for the extensions parameters of getSaveFilePath()

void cinder::ImageIo::setSize | ( | int32_t | width,
|  | int32_t | height |
| ) |  |  | `[protected, inherited]`

void cinder::ImageIo::setColorModel | ( | ColorModel | colorModel | ) | `[protected, inherited]`

void cinder::ImageIo::setDataType | ( | DataType | aDataType | ) | `[protected, inherited]`

void cinder::ImageIo::setChannelOrder | ( | ChannelOrder | aChannelOrder | ) | `[protected, inherited]`

## Member Data Documentation

int32_t cinder::ImageIo::mWidth`[protected, inherited]`

int32_t cinder::ImageIo::mHeight`[protected, inherited]`

ColorModel cinder::ImageIo::mColorModel`[protected, inherited]`

DataType cinder::ImageIo::mDataType`[protected, inherited]`

ChannelOrder cinder::ImageIo::mChannelOrder`[protected, inherited]`

The documentation for this class was generated from the following file:

- include/cinder/ImageIo.h